<template>
  <vab-dialog v-model="visible" append-to-body title="选择用户" width="840px" @close="close">
    <el-form ref="formRef" :inline="true" :model="queryParams">
      <el-form-item label="用户名称" prop="userName">
        <el-input v-model="queryParams.userName" clearable placeholder="请输入用户名称" style="width: 180px" @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="手机号码" prop="phonenumber">
        <el-input
          v-model="queryParams.phonenumber"
          clearable
          placeholder="请输入手机号码"
          style="width: 180px"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button icon="Search" type="primary" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row>
      <el-table ref="refTable" :data="userList" height="260px" @row-click="clickRow" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" />
        <el-table-column label="用户名称" prop="userName" :show-overflow-tooltip="true" />
        <el-table-column label="用户昵称" prop="nickName" :show-overflow-tooltip="true" />
        <el-table-column label="邮箱" prop="email" :show-overflow-tooltip="true" />
        <el-table-column label="手机" prop="phonenumber" :show-overflow-tooltip="true" />
        <el-table-column align="center" label="状态" prop="status">
          <template #default="scope">
            <dict-tag :options="sys_normal_disable" :value="scope.row.status" />
          </template>
        </el-table-column>
        <el-table-column align="center" label="创建时间" prop="createTime" width="180" />
      </el-table>
      <pagination
        v-show="total > 0"
        v-model:limit="queryParams.pageSize"
        v-model:page="queryParams.pageNum"
        :total="total"
        @pagination="getList"
      />
    </el-row>
    <template #footer>
      <el-button type="primary" @click="handleSelectUser">确 定</el-button>
      <el-button @click="visible = false">取 消</el-button>
    </template>
  </vab-dialog>
</template>

<script lang="ts" setup>
import { authUserSelectAll, unallocatedUserList } from '/@/api/roleManagement'

defineOptions({
  name: 'RoleSelectUser',
})

const { proxy } = getCurrentInstance() as any
const { sys_normal_disable } = proxy.useDict('sys_normal_disable')

const emit = defineEmits(['fetch-data'])

const props = defineProps({
  roleId: {
    type: [Number, String],
  },
})

const userList = ref([])
const visible = ref(false)
const total = ref(0)
const userIds = ref([])

const queryParams = reactive<any>({
  pageNum: 1,
  pageSize: 10,
  roleId: undefined,
  userName: undefined,
  phonenumber: undefined,
})

function close() {
  visible.value = false
}

// 显示弹框
function show() {
  queryParams.roleId = props.roleId
  getList()
  visible.value = true
}

/**选择行 */
function clickRow(row: any) {
  proxy.$refs['refTable'].toggleRowSelection(row)
}

// 多选框选中数据
function handleSelectionChange(selection: any) {
  userIds.value = selection.map((item: any) => item.userId)
}

// 查询表数据
function getList() {
  unallocatedUserList(queryParams).then((res: any) => {
    userList.value = res.rows
    total.value = res.total
  })
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm('queryRef')
  handleQuery()
}

/** 选择授权用户操作 */
function handleSelectUser() {
  const roleId = queryParams.roleId
  const uIds = userIds.value.join(',')
  if (uIds == '') {
    $baseMessage('请选择要分配的用户', 'error')
    return
  }
  authUserSelectAll({ roleId, userIds: uIds }).then((res: any) => {
    $baseMessage(res.msg, 'success')
    visible.value = false
    emit('fetch-data')
  })
}

defineExpose({
  show,
})
</script>
